.text
.globl _bounce,_call_stack_pointer
.globl _kernel_stack,_called,_startit,_initial,_enn
.globl _sig_count,_sig_counts,_sig_handler,_get_signal,_sig_giveup
.globl _start_restorer,_end_restorer

_called:
#	jmpf	$0xf,_bounce
	.byte 0xea
	.long _bounce
	.byte 0x0f,0x00
	#call _bounce:$0xf # change to standard code segment

_startit:
	movl _enn,%eax
	movl %eax,%ebx
	movl %eax,%ecx
	movl %eax,%edx
	movl _call_stack_pointer,%eax
	movl %eax,%esp
	movl $0x27,%ax
	movl %ax,%ds
	movl %ax,%ss
	movl %ax,%es
	mov %ax,%fs
	mov %ax,%gs
	movl %ebx,%eax
#	.byte 0xff # far jump to program code segment 
#	.long _initial
#	.byte 0x1f
#	.byte 0x00

	.byte 0xea
	.long 0
	.byte 0x1f
	.byte 0x00
	

_bounce:
	pushfl
	pushl %ebp 
	pushl %edi 
	pushl %esi 
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
	movl %eax,%ebx
	movl %esp,%ecx
	movl $0x17,%eax # data segment
	mov %ax,%ds
	mov %ax,%ss
	mov %ax,%es
	mov %ax,%fs
	mov %ax,%gs
	movl %ecx,_call_stack_pointer
	movl _kernel_stack,%eax
	movl %eax,%esp
	call _system_call
	cmpl $0,_sig_count
	je 2f
try_signal:
	call _sig_handler
2:
	movl _call_stack_pointer,%eax
	movl %eax,%esp
	movl $0x27,%eax
	movl %ax,%ds
	movl %ax,%ss
	movl %ax,%es
	movl %ax,%fs
	movl %ax,%gs
	movl %ebx,%eax
	popl %eax
	popl %ebx
	popl %ecx
	popl %edx
	popl %esi
	popl %edi
	popl %ebp
	popfl 
	lret

# this routine gets copied into xenix segment
# note segments don't change
_start_restorer:
	popl %eax # dispose of argument to signal handler 
	popl %eax
	popl %ebx
	popl %ecx
	popl %edx
	popl %esi
	popl %edi
	popl %ebp
	popfl 
	lret
_end_restorer:

_get_signal:
	# test for "kernel" mode
	cmp $0xf,%dx
	je 1f
	mov %ss,%ax
	cmp $0x17,%ax
	je 1f
	mov %ds,%ax
	cmp $0x17,%ax
	je 1f
	jmp 2f
 
1:
	# increment signal count
	ss:mov 4(%esp),%edx
	mov %ds,%cx
	mov $0x17,%ax
	mov %ax,%ds
	incl _sig_count
	incl _sig_counts(%edx)
	mov %cx,%ds
	ret # normal return procedure will work here
2:
# push stuff the kernel didn't
	pushl %ebx
	pushl %esi
	pushl %edi
	pushl %ebp
	mov $0x17,%ax
	mov %ax,%ss
	mov %ax,%es
	mov %ax,%fs
	mov %ax,%gs
	mov %ax,%ds
	mov %esp,%eax
	movl %eax,_call_stack_pointer
	movl _kernel_stack,%eax
	movl %eax,%esp
	call _adjust_stack
        jmp try_signal
